main(){
	maps\mp\mp_chelm_fx::main();
	maps\mp\_load::main();
	
	setExpFog(0.0001, 0.55, 0.6, 0.55, 0);
	ambientPlay("ambient_chelm");
	
	game["allies"] = "american";
	game["axis"] = "german";
	game["attackers"] = "allies";
	game["defenders"] = "axis";
	game["american_soldiertype"] = "normandy";
	game["german_soldiertype"] = "normandy";
	
	setcvar("r_glowbloomintensity0","1");
	setcvar("r_glowbloomintensity1","1");
	setcvar("r_glowskybleedintensity0",".25");
	
	doHQ();
	//Dynamic lighting fx for Dynamic light enabled setting in DX9
	thread doLantern();
	thread doCanon_light();
	//thread doChandalier(); //FPS drops too much for me (geforceFx)
	
	thread doSmoke();

	//Random passage loader
	level thread doRandom();
}
doHQ(){
	if(getcvar("g_gametype") == "hq")
	{
		level.radio = [];
		radioloc = getentarray("radio", "targetname");
		logPrint("Number of radios: " + radioloc.size + "\n");
		println("Number of radios:: " + radioloc.size + "\n");
		for(i=0; i<radioloc.size; i++){
			level.radio[i] = spawn("script_model", (radioloc[i].origin));
			level.radio[i].angles = (radioloc[i].angles);
			logPrint("Radio " + i + " set at (" + radioloc[i].origin + "), angles of (" + radioloc[i].angles + ") \n");
			println("Radio " + i + " set at (" + radioloc[i].origin + "), angles of (" + radioloc[i].angles + ") \n");
		}
	}
}
doSmoke(){
	smokeorigin = getentarray("smoke", "targetname");
	level._effect["thin_light_smoke_M"]	= loadfx ("fx/smoke/thin_light_smoke_M.efx");  
	for(i=0; i<smokeorigin.size; i++){
		maps\mp\_fx::loopfx("thin_light_smoke_M", (smokeorigin[i].origin), 1, (smokeorigin[i].origin+(0,0,100)));
	}
}

// oraco - dynamic lights for the church chandaliers !!!high graphic requirement!!!
doChandalier(){
	chan_light = loadfx("fx/chelm/chandalier_light.efx");
	chandalier_light = getentarray("fx_chandalier", "targetname");
	while(1){
		if(!isdefined(chandalier_light)) break;
		for(k=0; k<chandalier_light.size; k++){
			if(isdefined(chandalier_light[k]))
				playfx(chan_light, chandalier_light[k].origin+(0,0,72));
			else 
				continue;
		}
		wait 20;
	}
}
// oraco - dynamic lights for arty canon lights
doCanon_light(){
	c_light = loadfx("fx/chelm/canon_light.efx");
	canon_light = getentarray("fx_canon_light", "targetname");
	while(1){
		if(!isdefined(canon_light)) break;
		for(k=0; k<canon_light.size; k++){
			if(isdefined(canon_light[k]))
				playfx(c_light, canon_light[k].origin);
			else 
				continue;
		}
		wait 20;
	}
}
//==============================Lantern fx starts============================
/*	oraco - lantern fx func with lantern flame, dynamic lighting, and off if damaged(off delay 2sec max)
	MAP REQUIREMENTS:
	make script_model, model:xmodel/light_lantern_on, targetname: fx_lantern#, #=unique lantern count
	make damage_trigger, target: fx_lantern#, fx_lantern_trig, linked with the script_model lantern
	place the damage trigger where the lantern model is, if done correctly, u see a red link between them
*/
doLantern(){
	//get all lantern damage triggers in the map
	lantern_trig = getentarray("fx_lantern_trig", "targetname");
	if(isdefined(lantern_trig)){
		//for each lantern damage trigger in map we spawn thread to think
		for(k=0; k<lantern_trig.size; k++){
			if(isdefined(lantern_trig[k])){
				//set lantern on at first
				lantern_trig[k].pers["switch"] = 1;
				lantern_trig[k] thread lantern_think();
				lantern_trig[k] thread lantern_switch();
			}
		}
	}
}
//thread to check if lantern is being destroyed, if so respawn in 2 mins
lantern_switch(){
	respawntime = 120;
	//loop damage check forever
	while(1){
		self.pers["switch"] = 1;
		self waittill ("damage", amount ,attacker);
		self.pers["switch"] = 0;
		wait respawntime;
	}
}
//lantern fx loop
lantern_think(){
	//get entity of the damage trigger's target, which is the lantern script model
	lantern = getent(self.target, "targetname");
	smallfire = loadfx("fx/chelm/lantern.efx");
	lanternlight = loadfx("fx/chelm/lantern_light.efx");
	//loop fx forever
	while(1){
		if(!isdefined(lantern)) break;
		//if the switch is on then we display fx, else we dont
		if(self.pers["switch"]==1){
			playfx(smallfire, lantern.origin+(0,0,7));
			playfx(lanternlight, lantern.origin+(randomInt(8)-4,randomInt(8)-4,randomInt(8)+3));
			wait 2;
		}
		else
			wait 1;
	}
}
//================================Lantern fx ends=============================
//==============================Random passage/element starts=========================
/* 	oraco -	Preset obstacles loaded into the map outside players view will be randomly
			selected to obstruct passages or place objects at each round/map load.
	Map Requirement:
		Select the brush/brushes that you want to remove and make script_brushmodel, set its targetname
		to something unique such as "blockage1", make a script_origin somewhere near this script brush and set its
		targetname to "ran_passage" for passage and "ran_element" for element placement; set its target to "blockage1"
		the same name as your script origin's targetname, if all done correctly you will see the origin points to one
		of the models or brushes. Thats it!
*/
doRandom(){
	level endon("intermission");
	ran_passage = getentarray("ran_passage", "targetname");
	ran_element = getentarray("ran_element", "targetname");
	
	//init random passage obstruct
	for(k=0; k<ran_passage.size; k++){
		//initialize all random passage obstacles to set = true
		ran_passgroup = getentarray(ran_passage[k].target, "targetname");
		for(i=0; i<ran_passgroup.size; i++){
			ran_passgroup[i].set = true;
			ran_passgroup[i].setloc = ran_passgroup[i].origin;
		}
	}
	//init random element placement
	for(j=0; j<ran_element.size; j++){
		//initialize all random elements to set = true
		ran_elegroup = getentarray(ran_element[j].target, "targetname");
		for(i=0; i<ran_elegroup.size; i++){
			ran_elegroup[i].set = true;
			ran_elegroup[i].setloc = ran_elegroup[i].origin;
		}
	}
	//main loop for random generation
	while(1){
		//pass chance of blockage to each obstacle's script origin
		for(k=0; k<ran_passage.size; k++){
			if(isdefined(ran_passage[k].chance))
				chance = randomInt(ran_passage[k].chance);
			else{
				//1/3 chance of obstruct
				chance = randomInt(2);
			}
			ran_passage[k] thread ran_think(chance);
		}
		//pass chance of appearing of each element's script origin
		for(k=0; k<ran_element.size; k++){
			//1/3 chance of appearing
			if(isdefined(ran_element[k].chance))
				chance = randomInt(ran_element[k].chance);
			else{
				//1/3 chance of obstruct
				chance = randomInt(2);
			}
			ran_element[k] thread ran_think(chance);
		}
		self waittill("round_started");
	}
}
//set or unset think
ran_think(chance){
	ran_group = getentarray(self.target, "targetname");
	if(chance == 1){
		for(k=0; k<ran_group.size; k++){
			ran_group[k] thread ran_set(ran_group[k].setloc);
		}
	}
	else{
		for(k=0; k<ran_group.size; k++){
			ran_group[k] thread ran_unset(ran_group[k].setloc);
		}
	}
}
//set the obstacle to obstruct this passage
ran_set(oldloc){
	if(!(self.origin == oldloc))
		self.origin = oldloc;
}
//collect all obstacles into the bag under the map		
ran_unset(oldloc){
	if(self.origin == oldloc)
		self.origin += (0,0,-1000);
}
//==============================Random passage/element ends=========================